#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

FILE *log_fp;

void __attribute__ ((constructor)) SGO_init(void);
void __attribute__ ((destructor)) SGO_fini(void);

int Game_Main(const char *path, const char *udn)
{
	int i,err; 
	char cmd[100];

	/* for keyboard and mouse */
	mode_t mode = S_IFCHR;
	mode_t perm = 0666;
	dev_t dev;
	char device[100];
	umask(0);
	mkdir("/dtv/usb", S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
	mkdir("/dtv/usb/dev", S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
	mkdir("/dtv/usb/dev/input", S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
	for (i = 0; i < 7; i++) {
		dev = makedev(13, 64 + i);
		sprintf(device, "/dtv/usb/dev/input/event%d", i);
		mknod(device, mode | perm , dev);
	}
	for (i = 0; i < 2; i++) {
		dev = makedev(13, 32 + i);
		sprintf(device, "/dtv/usb/dev/input/mouse%d", i);
		mknod(device, mode | perm, dev);
	}
	dev = makedev(13, 63);
	mknod("/dtv/usb/dev/input/mice", mode | perm, dev);

	/* for usb cd-drives */
	mode = S_IFBLK;
	dev = makedev(11, 0);
	mknod("/dtv/usb/dev/sr0", mode | perm, dev);

	/* loop devices */
	for (i = 0; i < 7; i++) {
		dev = makedev(7, i);
		sprintf(device, "/dtv/usb/dev/loop%d", i);
		mknod(device, mode | perm, dev);
	}

	sprintf(cmd, "%s/rcSGO %s/ &\n", path, path);
	err = system(cmd);

	fprintf(log_fp, "ready\n");

	return 0;
}

void SGO_init(void){
	log_fp = fopen("/dev/kmsg", "a+");
	fprintf(log_fp, "####################\n");
}
void SGO_fini(void){
	fprintf(log_fp, "%s: unload\n", __FUNCTION__);
	fflush(log_fp);
	fclose(log_fp);

}
